{-# LANGUAGE OverloadedStrings #-}

import Network.Metric
import Control.Concurrent
import System.Random
import Data.Pool
import Network.HostName
import qualified Data.ByteString.Char8 as BS
import Control.Exception
import Control.Monad

pushLoop pool n =
  when (n > 0) $ do
    threadDelay 100000 -- 100 ms
    writeMetrics pool `catch` reportIOException
    print n
    pushLoop pool $ n - 1

writeMetrics pool = do
  counter <- randomRIO (50, 150)
  timer <- randomRIO (50.0, 150.0)
  gauge <- randomRIO (50.0, 150.0)
  withResource pool $ \s -> do
    push s $ Counter "example.store" "counter" counter
    push s $ Timer "example.store" "timer" timer
    push s $ Gauge "example.store" "gauge" gauge

reportIOException :: IOException -> IO ()
reportIOException e =
  putStrLn $ "Something is wrong: " ++ show e

createSink = do
  host <- getHostName
  open Graphite (BS.pack host) "localhost" 2003

main = do
  pool <- createPool createSink close 1 120 5
  pushLoop pool 1000
